/*
	Calculadora Estrutura de Dados I - calculadora.cpp
	
	Campinas Brasil, 12/2002	Cesar Henrique Kallas	opensrc@gmx.net		(RA 02099224)
					Daniel F. Machado	daniel.fm@uol.com.br	(RA 02508224)
	Pontifcia Universidade Catlica de Campinas
	
	Escopo: calculadora com uso de pilha e lista
	Funes:	+  -  /  * ;
	Funcionamento:	Entrada dgito a dgito, se for nmero, armazena-se em uma lista linear,
					quando digitar um sinal, transforma-se toda a lista linear em um numero apenas
					e o armazena em uma pilha p, o sinal digitado passa para a pilha q.
					Digita-se o segundo operando, apos o operador, quando pressionar enter ou '=',
					parte-se para o processo da conta, com operando 1 (pilha p), operador(pilha q)
					e operando 2 (visor).
					O Resultado passa para a pilha p, assim, ja tem o operando 1, para conta 
					posterior.
	Incluses:	pilha.h, Lista.h
	
*/

/* #include <conio.h>
Se vc tiver a biblioteca acima, podera usar a funcao getch() para pegar um caracter por vez, porem
a funcao getchar() da biblioteca stdio.h faz o papel.
Mas o interessante eh usar o conio.h mesmo, pq vai ser a unica maneira perfeita de funcionar.
*/

#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>

typedef int tipo_do_elemento;
#include "pilha.h"

typedef char tipo_elemento;
#include "Lista.h"

#define	cls	system("clear"); /* para windows use system("cls"); */
#define pause system("sleep 2"); /* para windows use system("pause") */


void imprime(int saida)
{
	cls;
	cout << "\xC9" << flush;
	for(int i=0;i<=16;i++)	cout << "\xCD" << flush;
		cout << "\n" << "\xBA  " << saida << "\n\xCC" << flush;
	for(int i=0;i<=15;i++)
		cout << "\xCD" << flush;
	cout << "\xBB" << flush;
	cout << "\n\xBA\t\t \xBA\n\xBA " << flush;
	cout << "ESC : sair     \xBA\n\xBA" << " DEL : limpar   \xBA" << flush;
	cout << "\n\xBA\t\t \xBA\n\xC8" << flush;
	for(int i=0;i<=15;i++)	cout << "\xCD" << flush;
	cout << "\xBC" << flush;
}

char verificar_operacoes(char c)
{
	switch(c)
	{
		case '+' :	return 0;
		case '-' :	return 0;
		case '*' :	return 0;
		case '/' :	return 0;
		case '=' :	return 1;
		case 13  :	return 1;	/* pressionar enter */
		case 83	 :	return 2;	/* pressionar del */
	}
}

int calcular(int op1,int op2,char opc)	/* funcao que faz as contas */
{
	switch(opc)
	{
		case '+' :	return op1+op2;
		case '-' :	return op1-op2;
		case '*' :	return op1*op2;
		case '/' :	return op1/op2;
		case '=' :	return op1;
		case 13	 :	return op1;
	}
}

int n_inteiro(Lista &l)		/* transforma toda a lista linear l em apenas um numero */
{
	tipo_elemento v;
	int multi=1,soma=0;

	for(int i=compr(l);i>=1;i--)
	{
		v = consultar(l,i);
		soma += consultar(l,i) * multi ;
		multi *= 10;
	}
	return soma;
}

int main()
{
	Pilha p,q;
	Lista l;
	init(q);
	init(p);
	init(l);
		
	int visor=NULL,op1=NULL,resultado=NULL;
	char c=NULL,ok=NULL,opc=NULL;
	
	imprime(resultado);
	
	while(c!=27)
	{
		//c=getch();		/* recebe caracter a caracter */
		c = getchar();
		getchar(); /* lima buffer */
		ok=verificar_operacoes(c);
		
		if(ok==2){	/* reinicia calculadora */
			visor=NULL,op1=NULL,resultado=NULL;
			c=NULL,ok=NULL,opc=NULL;
			init(q);
			init(p);
			init(l);
			imprime(resultado); 
		}

		if(isdigit(c)!=0) /* imprime se for numero */
		{
			if(compr(l)<=9) /* soh aceita 10 digitos */
			{
				inserir(l,c-48,compr(l)+1);
				visor = n_inteiro(l); /* pega da lista numero a numero, e converte em somente 1 numero inteiro */
				imprime(visor);
			}
		}
			
			else
		{
			if(visor!=NULL && ok==0 && vazia(p))
			{
				push(p,visor);
				init(l);
				push(q,c);
				visor=NULL;
			}
			
			if(!vazia(p) && ok==0)
				push(q,c);
							
			if(visor!=NULL && ok==1 && !vazia(p)) // = ou enter
			{
				op1=pop(p);
				opc=pop(q);
				resultado=calcular(op1,visor,opc);
				imprime(resultado);
				push(p,resultado);	/* coloca o resultado na pilha para conta posterior  */
				visor=NULL;	/* o valor de visor ja foi usado, intao a calc retorna ao seu estado inicial, menos as pilhas */
				init(l);
				push(q,c);
			}
		}
	}				
}


